'*******************************************************************************
'CronEdit v1.3
'********************************************************************************
'2006.10.01
'
'http://supware.net
'doug@supware.net
'
'Copyright (C) 2006 Doug Melton
'
'This program is free software; you can redistribute it and/or
'modify it under the terms of the GNU General Public License
'as published by the Free Software Foundation; either version 2
'of the License, or (at your option) any later version.
'
'This program is distributed in the hope that it will be useful,
'but WITHOUT ANY WARRANTY; without even the implied warranty of
'MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'GNU General Public License for more details.
'
'You should have received a copy of the GNU General Public License
'along with this program; if not, write to the Free Software
'Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
'******************************************************************************

Public Class OpenDialog
    Inherits System.Windows.Forms.Form
    Friend WithEvents treeView As System.Windows.Forms.TreeView

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call 

        Me.treeView.Location = New System.Drawing.Point(0, 0)
        Me.treeView.Size = Me.ClientSize
    End Sub

    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        MyBase.Dispose(disposing)
    End Sub

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents MainMenu2 As System.Windows.Forms.MainMenu
    Friend WithEvents mnuOK As System.Windows.Forms.MenuItem
    Friend WithEvents mnuCancel As System.Windows.Forms.MenuItem
    Friend WithEvents ilFileIcons As System.Windows.Forms.ImageList
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Dim TreeNode1 As System.Windows.Forms.TreeNode = New System.Windows.Forms.TreeNode
        Dim resources As System.Resources.ResourceManager = New System.Resources.ResourceManager(GetType(OpenDialog))
        Me.treeView = New System.Windows.Forms.TreeView
        Me.ilFileIcons = New System.Windows.Forms.ImageList
        Me.MainMenu2 = New System.Windows.Forms.MainMenu
        Me.mnuOK = New System.Windows.Forms.MenuItem
        Me.mnuCancel = New System.Windows.Forms.MenuItem
        '
        'treeView
        '
        Me.treeView.ImageList = Me.ilFileIcons
        TreeNode1.ImageIndex = 0
        TreeNode1.SelectedImageIndex = 0
        TreeNode1.Text = "Smartphone [+]"
        Me.treeView.Nodes.Add(TreeNode1)
        Me.treeView.ShowRootLines = False
        Me.treeView.Size = New System.Drawing.Size(176, 128)
        '
        'ilFileIcons
        '
        Me.ilFileIcons.Images.Add(CType(resources.GetObject("resource"), System.Drawing.Image))
        Me.ilFileIcons.Images.Add(CType(resources.GetObject("resource1"), System.Drawing.Image))
        Me.ilFileIcons.Images.Add(CType(resources.GetObject("resource2"), System.Drawing.Image))
        Me.ilFileIcons.Images.Add(CType(resources.GetObject("resource3"), System.Drawing.Image))
        Me.ilFileIcons.ImageSize = New System.Drawing.Size(16, 16)
        '
        'MainMenu2
        '
        Me.MainMenu2.MenuItems.Add(Me.mnuOK)
        Me.MainMenu2.MenuItems.Add(Me.mnuCancel)
        '
        'mnuOK
        '
        Me.mnuOK.Text = "OK"
        '
        'mnuCancel
        '
        Me.mnuCancel.Text = "Cancel"
        '
        'OpenDialog
        '
        Me.ClientSize = New System.Drawing.Size(176, 177)
        Me.Controls.Add(Me.treeView)
        Me.Menu = Me.MainMenu2
        Me.Text = "Open File"

    End Sub

#End Region

    Public Filter As String
    Public FilterIndex As Integer
    Public FileName As String = "\Storage\My Documents"
    Public Sub Reset()
        'dummy
    End Sub

    Private Sub FillDir(ByRef node As TreeNode, ByVal path As String)
        If node.Nodes.Count = 0 And System.IO.Directory.Exists(path) Then
            Dim dirs() As String = System.IO.Directory.GetFileSystemEntries(path)
            Dim i As Integer
            For i = 0 To dirs.Length - 1
                Dim dispName As String = dirs(i).Substring(dirs(i).LastIndexOf("\") + 1)
                Dim newNode As TreeNode = node.Nodes.Add(dispName)
                Dim dirInfo As System.IO.DirectoryInfo = New System.IO.DirectoryInfo(path + "\" + dispName)
                Dim isDir As Boolean = System.IO.Directory.Exists(dirs(i))
                If isDir Then
                    newNode.ImageIndex = 1
                    newNode.SelectedImageIndex = 2
                Else
                    newNode.ImageIndex = 3
                    newNode.SelectedImageIndex = 3
                End If
            Next
        End If
    End Sub

    Private Sub OpenDialog_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        FillDir(Me.treeView.Nodes(0), "\")
        Me.treeView.Focus()
    End Sub

    Private Sub mnuOK_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuOK.Click
        If treeView.SelectedNode.FullPath.Length > 14 Then
            Me.FileName = treeView.SelectedNode.FullPath.Substring(14)
        Else
            Me.FileName = "\"
        End If
        Me.DialogResult = DialogResult.OK
    End Sub

    Private Sub treeView_AfterSelect(ByVal sender As System.Object, ByVal e As System.Windows.Forms.TreeViewEventArgs) Handles treeView.AfterSelect
        If treeView.SelectedNode.FullPath.Length > 14 Then
            Dim path As String = Me.treeView.SelectedNode.FullPath.Substring(15)
            FillDir(Me.treeView.SelectedNode, path)
        End If
    End Sub

    Private Sub mnuCancel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuCancel.Click
        Me.DialogResult = DialogResult.Cancel
        Me.Hide()
    End Sub

    Private Sub treeView_BeforeExpand(ByVal sender As Object, ByVal e As System.Windows.Forms.TreeViewCancelEventArgs) Handles treeView.BeforeExpand
        If treeView.SelectedNode.FullPath.Length = 14 Then
            If treeView.SelectedNode.IsExpanded Then
                treeView.SelectedNode.Text = "Smartphone [-]"
            Else
                treeView.SelectedNode.Text = "Smartphone [+]"
            End If
        End If
    End Sub
End Class
